#include <avr/io.h>
#include <avr/eeprom.h>
#include "../ixtdmv11hw.h"
#include "../ixtdm_com.h"

// Client-Adresse (EEPROM)
uint8_t com_clientaddr;
uint8_t EEMEM eeprom_com_clientaddr = 1;

// Kommunikationsempfangspuffer
t_com_recvdata com_data;

// Hauptfunktion
int main()
{
	// Hardware initialisieren
	init_hardware();
	init_pwm_inv();

	// Einstellungen aus EEPROM laden
	com_clientaddr = eeprom_read_byte(&eeprom_com_clientaddr);

	// Kommunikation initialisieren
	init_com(com_clientaddr);

	// Hauptschleife
	while(1)
	{
		if(com_get(&com_data))
		{
			// War es ein Broadcast-Paket an Adresse 0?
			/*
			if(com_data.flag_broadcast)
			{
			}
			*/
			// Einfache Abbildung der Kanle 1-3 auf die PWMs 1-3
			switch(com_data.channel)
			{
				case 1: SET_PWM1(com_data.data); break;
				case 2: SET_PWM2(com_data.data); break;
				case 3: SET_PWM3(com_data.data); break;
				default: break;
			}
		}
	}
}
