#include <avr/io.h>
#include <util/delay.h>
#include <stdlib.h>

#include "../ixtdmv11hw.h"
#include "helpers.h"

// globale Variablen
uint8_t rot = 255, blau = 255, gruen = 255, gruen_target = 0, rot_target = 0, blau_target = 0;

// Farbe anpassen
void updatecolor(void)
{
	// Hinfaden
	if(blau != blau_target)
	{
		if(blau > blau_target) blau--; else blau++;
	}
	if(rot != rot_target)
	{
		if(rot > rot_target) rot--; else rot++;
	}
	if(gruen != gruen_target)
	{
		if(gruen > gruen_target) gruen--; else gruen++;
	}
	// zuweisen
	SET_PWM1(rot);
	SET_PWM2(gruen);
	SET_PWM3(blau);
}
// automatisches faden
void fadeto(uint8_t _rot, uint8_t _gruen, uint8_t _blau)
{
	rot_target = _rot;
	gruen_target = _gruen;
	blau_target = _blau;
	while(rot != rot_target || gruen != gruen_target || blau != blau_target)
	{
		updatecolor();
		_delay_ms(10);
	}
}

// Haupteinsprung
color_rgb rgb;
color_hsv hsv;

int main(void)
{
	// HW
	init_hardware();

	// PWM
	init_pwm_inv();

	// Farben
	hsv.h = 0;
	hsv.s = 200;
	hsv.v = 255;

	// Hauptschleife
	while(1)
	{
		// Farbe wechseln, wenn Taste gedrckt
		if(KEY_PRESSED) hsv.h += 1;
		if(hsv.h > 1535) hsv.h -= 1535;
		rgb = driver_hsv2rgb(hsv);
		fadeto(rgb.r, rgb.g, rgb.b);

		/*
		// Automatisches Faden...
		fadeto(255,0,0);
		fadeto(0,0,0);
		fadeto(0,255,0);
		fadeto(0,0,255);
		fadeto(0,0,0);
		fadeto(255,255,255);
		fadeto(255,255,0);
		fadeto(255,0,0);
		fadeto(0,0,255);
		fadeto(0,255,0);
		fadeto(0,0,0);
		*/
	}
}
