#ifndef _IXTDM_COM_H_
#define _IXTDM_COM_H_

// Takt
#ifndef F_CPU
#warning "F_CPU war noch nicht definiert, wird nun nachgeholt mit 16 MHz"
#define F_CPU 16000000L    // Systemtakt in Hz, das L am Ende ist wichtig, NICHT UL verwenden! 
#endif

// Baudrate
#define BAUD 19200L          // Baudrate, das L am Ende ist wichtig, NICHT UL verwenden!

// Baudratenberechnungen
#define UBRR_VAL ((F_CPU+BAUD*8)/(BAUD*16)-1)   // clever runden
#define BAUD_REAL (F_CPU/(16*(UBRR_VAL+1)))     // Reale Baudrate
#define BAUD_ERROR ((BAUD_REAL*1000)/BAUD-1000) // Fehler in Promille 
 
#if ((BAUD_ERROR>10) || (-BAUD_ERROR<10))
  #error Systematischer Fehler der Baudrate groesser 1% und damit zu hoch! 
#endif

// Dauer in us fr 2 Byte (fr Startpuls)
#define COM_PULSE (((16*1000000L)/BAUD)+1)

// Empfangene Daten
#define COM_RECVBUFFER 5
typedef volatile struct {
	volatile uint8_t flag_broadcast:1;
	volatile uint8_t channel;
	volatile uint8_t data;
} t_com_recvdata;

// Prototypen
void init_com(uint8_t addr);
void com_send(uint8_t addr, uint8_t channel, uint8_t data);
uint8_t com_get(t_com_recvdata * data);

#endif
