#include <avr/io.h>
#include "ixTDMv11HW.h"

// Standard-Hardware initialisieren
void init_hardware()
{
	// Port B
	// Peripherie, SPI, Quarz
	// Pullup fr Taster an
	PORTB = (1<<PB0);
	DDRB  = (0<<PB0) | (1<<PB1) | (1<<PB2) | (1<<PB3) | (0<<PB4) | (1<<PB5) | (0<<PB6) | (0<<PB7);
	// Port C
	// Erweiterungsport (PC0..PC5)
	// Pullups aktivieren, damit nichts floatet
	PORTC = 0x3F;
	DDRC  = 0x00;
	// Port D
	// Peripherie
	PORTD = 0x00;
	DDRD  = (0<<PD0) | (1<<PD1) | (0<<PD2) | (1<<PD3) | (1<<PD4) | (1<<PD5) | (1<<PD6) | (1<<PD7);
}

// 3 8-Bit PWMs einrichten
// ACHTUNG: invertiert! -> Ausschalten des Ausgangs damit mglich bei Wert 255
// Timer-Takt: clk/64
void init_pwm_inv()
{
	// Timer 1 PWM
	// inverting Fast PWM, clk/64
	OCR1A = 255; // Kanal 1
	OCR1B = 255; // Kanal 2
	TCCR1A = (1<<COM1A1) | (1<<COM1A0) | (1<<COM1B1) | (1<<COM1B0) | (0<<WGM11) | (1<<WGM10);
	TCCR1B = (0<<ICNC1) | (0<<ICES1) | (0<<WGM13) | (1<<WGM12) | (0<<CS12) | (1<<CS11) | (1<<CS10);

	// Timer 2 PWM
	// nur auf OCR2B, inverting Fast PWM, clk/64
	OCR2A = 0;
	OCR2B = 255; // Kanal 3
	TCCR2A = (0<<COM2A1) | (0<<COM2A0) | (1<<COM2B1) | (1<<COM2B0) | (1<<WGM21) | (1<<WGM20);
	TCCR2B = (0<<FOC2A) | (0<<FOC2B) | (0<<WGM22) | (1<<CS22) | (0<<CS21) | (0<<CS20);
}

// PWMs setzen, mit Invertierung, so dass 0 = aus, 255 = 99.9%
