#ifndef _IXTDMV11HW_H_
#define _IXTDMV11HW_H_

// Hilfsmakros
#define LED1_ON PORTD|=(1<<PD5)
#define LED1_OFF PORTD&=~(1<<PD5)
#define LED1_TOGGLE PORTD^=(1<<PD5)
#define LED2_ON PORTD|=(1<<PD6)
#define LED2_OFF PORTD&=~(1<<PD6)
#define LED2_TOGGLE PORTD^=(1<<PD6)
#define LED3_ON PORTD|=(1<<PD7)
#define LED3_OFF PORTD&=~(1<<PD7)
#define LED3_TOGGLE PORTD^=(1<<PD7)

#define KEY_PRESSED (!(PINB&(1<<PB0)))

#define IR_IN (PIND&(1<<PD2))

#define RS485_RECEIVE PORTD&=~(1<<PD4)
#define RS485_TRANSMIT PORTD|=(1<<PD4)

// Optimization improvements (Peter Dannegger)
// always inline function x:
/*
#define AIL(x)   static x __attribute__ ((always_inline)); static x

// PWM Hilfsfunktionen
AIL(void set_pwm1(uint8_t duty))
{
	OCR1A = ~duty;
}
AIL(void set_pwm2(uint8_t duty))
{
	OCR1B = ~duty;
}
AIL(void set_pwm3(uint8_t duty))
{
	OCR2B = ~duty;
}*/

// PWM Hilfsmakros
#define SET_PWM1(x) OCR1A=~ x
#define SET_PWM2(x) OCR1B=~ x
#define SET_PWM3(x) OCR2B=~ x

// Prototypen
void init_hardware();
void init_pwm_inv();

#endif
